import time
from subprocess import call
import grovepi
from dht2 import temp
from facial_recognition.facial_req import facial_rec
from zipper import zipper

print("Welcome to Group 16's Advanced Doorbell Plus!")
print("Please wait while we setup your doorbell")
print("This will only take a moment.")
print("")

# Runs the lcd file which displays the temperature and humidity
call("python3 lcd.py", shell=True)

# Hardware components that need to be connected
led_status = 3  # Connect LED Button to port D3
buzzer = 5  # Connect Buzzer to port D5
ranger = 7  # Connect ranger to Port D7

# Setting up Mail
SMTP_USERNAME = "iotg16@outlook.com"  # Mail id of the sender
SMTP_PASSWORD = "Group16!"  # Password of the sender


SMTP_RECIPIENT = input(
    "Please enter the email address the security footage should be sent to: "
)  # Mail id of the receiver


SMTP_SERVER = "smtp.office365.com"  # Address of the SMTP server
SSL_PORT = 587


# Ask the user if they want to run the rpi_camera_surveillance.py file which runs the camera

while True:
    run_live_feed = input("Would you like to view the live feed of the camera? (y/n): ")
    if run_live_feed == "y":
        call("python3 rpi_camera_surveillance.py", shell=True)
        break
    elif run_live_feed == "n":
        break
    else:
        print("Please enter a valid option")
        run_live_feed = input(
            "Would you like to view the live feed of the camera? (y/n): "
        )
        continue


while True:
    print()
    print("The process of adding photos of someone can only be done during startup")
    print("")
    face_req = input("Would you like to add photos of someone? No: 0, Yes: 1: ")

    if face_req == "0":
        print("Continuing without adding photos")
        print("..................................")
        break
    elif face_req == "1":
        call("cd facial_recognition; python3 headshots.py", shell=True)
        print("We are just backing up your files on the cloud!")
        call("cd facial_recognition; python3 cloudupload.py", shell=True)
        print("..................................")
        break
    else:
        print("Invalid input. Must be 0 or 1")
        continue

# Code keeps on looping in case of IO Error

sustained = False
sustained_track = 0

while True:
    try:
        while True:

            # If something is detected for 250 loops, around 3 seconds, continue.
            # This reduces the chance of random motion triggering the security features.
            while not sustained:

                ur_distance = grovepi.ultrasonicRead(ranger)

                if ur_distance < 100:
                    sustained_track += 1

                    if sustained_track > 75:
                        sustained = True

                else:
                    sustained_track = 0

            if ur_distance < 100:  # Runs only if distance is less than 100 cm

                # Prints Temperature and Humidity reading.
                x = temp()

                # Turn on the status LED to indicate that someone has arrived or there as been movement
                grovepi.digitalWrite(led_status, 1)

                # Make a sound on the Buzzer when movement is detected
                print("Buzzer Activated")
                grovepi.analogWrite(buzzer, 1)
                time.sleep(1)
                grovepi.analogWrite(buzzer, 0)
                print("Buzzer Stopped")

                # Takes video from Pi camera
                call(["raspivid -o myvid.h264 -w 640 -h 480 -t 6000"], shell=True)
                zipper()

                grovepi.digitalWrite(led_status, 0)  # Turn off the LED

                facial_rec(SMTP_RECIPIENT)

    except IOError:
        print("Error")
        continue
